Index: branches/2016/dev_NOC_2016/NEMOGCM/CONFIG/WAD_TEST_CASES/cpp_WAD_TEST_CASES.fcm
===================================================================
--- branches/2016/dev_NOC_2016/NEMOGCM/CONFIG/WAD_TEST_CASES/cpp_WAD_TEST_CASES.fcm	(revision 7339)
+++ branches/2016/dev_NOC_2016/NEMOGCM/CONFIG/WAD_TEST_CASES/cpp_WAD_TEST_CASES.fcm	(revision 7339)
@@ -0,0 +1,1 @@
+ bld::tool::fppkeys key_zdftke key_iomput key_mpp_mpi key_bdy key_nosignedzero key_mpp_rep
Index: branches/2016/dev_NOC_2016/NEMOGCM/NEMO/OPA_SRC/DIA/diawri.F90
===================================================================
--- branches/2016/dev_NOC_2016/NEMOGCM/NEMO/OPA_SRC/DIA/diawri.F90	(revision 7338)
+++ branches/2016/dev_NOC_2016/NEMOGCM/NEMO/OPA_SRC/DIA/diawri.F90	(revision 7339)
@@ -145,10 +145,10 @@
       CALL iom_put("e3v_0", e3t_0(:,:,:) )
       !
-      CALL iom_put( "e3t" , fse3t_n(:,:,:) )
-      CALL iom_put( "e3u" , fse3u_n(:,:,:) )
-      CALL iom_put( "e3v" , fse3v_n(:,:,:) )
-      CALL iom_put( "e3w" , fse3w_n(:,:,:) )
+      CALL iom_put( "e3t" , e3t_n(:,:,:) )
+      CALL iom_put( "e3u" , e3u_n(:,:,:) )
+      CALL iom_put( "e3v" , e3v_n(:,:,:) )
+      CALL iom_put( "e3w" , e3w_n(:,:,:) )
       IF( iom_use("e3tdef") )   &
-         CALL iom_put( "e3tdef"  , ( ( fse3t_n(:,:,:) - e3t_0(:,:,:) ) / e3t_0(:,:,:) * 100 * tmask(:,:,:) ) ** 2 )
+         CALL iom_put( "e3tdef"  , ( ( e3t_n(:,:,:) - e3t_0(:,:,:) ) / e3t_0(:,:,:) * 100 * tmask(:,:,:) ) ** 2 )
 
       CALL iom_put( "ssh" , sshn )                 ! sea surface height
Index: branches/2016/dev_NOC_2016/NEMOGCM/NEMO/OPA_SRC/DOM/domain.F90
===================================================================
--- branches/2016/dev_NOC_2016/NEMOGCM/NEMO/OPA_SRC/DOM/domain.F90	(revision 7338)
+++ branches/2016/dev_NOC_2016/NEMOGCM/NEMO/OPA_SRC/DOM/domain.F90	(revision 7339)
@@ -105,15 +105,15 @@
       IF( ln_linssh ) THEN          ! Fix in time : set to the reference one for all
          !       before        !          now          !       after         !
-         ;  gdept_b = gdept_0  ;   gdept_n = gdept_0   !        ---          ! depth of grid-points
-         ;  gdepw_b = gdepw_0  ;   gdepw_n = gdepw_0   !        ---          !
-         ;                     ;   gde3w_n = gde3w_0   !        ---          !
+            gdept_b = gdept_0  ;   gdept_n = gdept_0   !        ---          ! depth of grid-points
+            gdepw_b = gdepw_0  ;   gdepw_n = gdepw_0   !        ---          !
+                                   gde3w_n = gde3w_0   !        ---          !
          !                                                                  
-         ;    e3t_b =   e3t_0  ;     e3t_n =   e3t_0   ;   e3t_a =  e3t_0    ! scale factors
-         ;    e3u_b =   e3u_0  ;     e3u_n =   e3u_0   ;   e3u_a =  e3u_0    !
-         ;    e3v_b =   e3v_0  ;     e3v_n =   e3v_0   ;   e3v_a =  e3v_0    !
-         ;                     ;     e3f_n =   e3f_0   !        ---          !
-         ;    e3w_b =   e3w_0  ;     e3w_n =   e3w_0   !        ---          !
-         ;   e3uw_b =  e3uw_0  ;    e3uw_n =  e3uw_0   !        ---          !
-         ;   e3vw_b =  e3vw_0  ;    e3vw_n =  e3vw_0   !        ---          !
+              e3t_b =   e3t_0  ;     e3t_n =   e3t_0   ;   e3t_a =  e3t_0    ! scale factors
+              e3u_b =   e3u_0  ;     e3u_n =   e3u_0   ;   e3u_a =  e3u_0    !
+              e3v_b =   e3v_0  ;     e3v_n =   e3v_0   ;   e3v_a =  e3v_0    !
+                                     e3f_n =   e3f_0   !        ---          !
+              e3w_b =   e3w_0  ;     e3w_n =   e3w_0   !        ---          !
+             e3uw_b =  e3uw_0  ;    e3uw_n =  e3uw_0   !        ---          !
+             e3vw_b =  e3vw_0  ;    e3vw_n =  e3vw_0   !        ---          !
          !
          CALL wrk_alloc( jpi,jpj,   z1_hu_0, z1_hv_0 )
@@ -123,9 +123,9 @@
          !
          !        before       !          now          !       after         !
-         ;                     ;      ht_n =    ht_0   !                     ! water column thickness
-         ;     hu_b =    hu_0  ;      hu_n =    hu_0   ;    hu_a =    hu_0   ! 
-         ;     hv_b =    hv_0  ;      hv_n =    hv_0   ;    hv_a =    hv_0   !
-         ;  r1_hu_b = z1_hu_0  ;   r1_hu_n = z1_hu_0   ; r1_hu_a = z1_hu_0   ! inverse of water column thickness
-         ;  r1_hv_b = z1_hv_0  ;   r1_hv_n = z1_hv_0   ; r1_hv_a = z1_hv_0   !
+                                      ht_n =    ht_0   !                     ! water column thickness
+               hu_b =    hu_0  ;      hu_n =    hu_0   ;    hu_a =    hu_0   ! 
+               hv_b =    hv_0  ;      hv_n =    hv_0   ;    hv_a =    hv_0   !
+            r1_hu_b = z1_hu_0  ;   r1_hu_n = z1_hu_0   ; r1_hu_a = z1_hu_0   ! inverse of water column thickness
+            r1_hv_b = z1_hv_0  ;   r1_hv_n = z1_hv_0   ; r1_hv_a = z1_hv_0   !
          !
          CALL wrk_dealloc( jpi,jpj,   z1_hu_0, z1_hv_0 )
Index: branches/2016/dev_NOC_2016/NEMOGCM/NEMO/OPA_SRC/DOM/domvvl.F90
===================================================================
--- branches/2016/dev_NOC_2016/NEMOGCM/NEMO/OPA_SRC/DOM/domvvl.F90	(revision 7338)
+++ branches/2016/dev_NOC_2016/NEMOGCM/NEMO/OPA_SRC/DOM/domvvl.F90	(revision 7339)
@@ -874,15 +874,26 @@
             !
          ELSE                                   !* Initialize at "rest"
-            e3t_b(:,:,:) = e3t_0(:,:,:)
-            e3t_n(:,:,:) = e3t_0(:,:,:)
-            sshn(:,:) = 0.0_wp
-
-            IF( ln_wd ) THEN
+            !
+            IF( ln_wd .AND. ( cp_cfg == 'wad' ) ) THEN
+               !
+               CALL wad_istate                  ! WAD test configuration : start from 
+                                                ! uniform T-S fields and initial ssh slope
+               ! needs to be called here and in istate which is called later.
+               ! Adjust vertical metrics
+               DO jk = 1, jpk
+                  e3t_n(:,:,jk) =  e3t_0(:,:,jk) * ( ht_0(:,:) + sshn(:,:) ) &
+                    &                            / ( ht_0(:,:) + 1._wp - ssmask(:,:) ) * tmask(:,:,jk)   &
+                    &            + e3t_0(:,:,jk)                               * (1._wp -tmask(:,:,jk))
+               END DO
+               e3t_b(:,:,:) = e3t_n(:,:,:)
+               !
+            ELSEIF( ln_wd ) THEN
+               !
               DO jj = 1, jpj
                 DO ji = 1, jpi
                   IF( e3t_0(ji,jj,1) <= 0.5_wp * rn_wdmin1 ) THEN
-                     e3t_b(ji,jj,:) = 0.5_wp * rn_wdmin1 
-                     e3t_n(ji,jj,:) = 0.5_wp * rn_wdmin1 
-                     e3t_a(ji,jj,:) = 0.5_wp * rn_wdmin1 
+                     e3t_b(ji,jj,:) = 0.5_wp * rn_wdmin1
+                     e3t_n(ji,jj,:) = 0.5_wp * rn_wdmin1
+                     e3t_a(ji,jj,:) = 0.5_wp * rn_wdmin1
                      sshb(ji,jj) = rn_wdmin1 - bathy(ji,jj)
                      sshn(ji,jj) = rn_wdmin1 - bathy(ji,jj)
@@ -891,4 +902,11 @@
                 ENDDO
               ENDDO
+               !
+            ELSE
+               !
+               e3t_b(:,:,:) = e3t_0(:,:,:)
+               e3t_n(:,:,:) = e3t_0(:,:,:)
+               sshn(:,:) = 0.0_wp
+               !
             END IF
 
Index: branches/2016/dev_NOC_2016/NEMOGCM/NEMO/OPA_SRC/DOM/domzgr.F90
===================================================================
--- branches/2016/dev_NOC_2016/NEMOGCM/NEMO/OPA_SRC/DOM/domzgr.F90	(revision 7338)
+++ branches/2016/dev_NOC_2016/NEMOGCM/NEMO/OPA_SRC/DOM/domzgr.F90	(revision 7339)
@@ -416,4 +416,146 @@
                IF(lwp) WRITE(numout,*) '         Depth = rn_bathy read in namelist'
                zdta(:,:) = rn_bathy
+!
+               IF( cp_cfg == 'wad' ) THEN
+                  SELECT CASE ( jp_cfg )
+                     !                                        ! ====================
+                     CASE ( 1 )                               ! WAD 1 configuration
+                        !                                     ! ====================
+                        !
+                        IF(lwp) WRITE(numout,*)
+                        IF(lwp) WRITE(numout,*) 'zgr_bat : Closed box with EW linear bottom slope'
+                        IF(lwp) WRITE(numout,*) '~~~~~~~~~~'
+                        !
+                        zdta = 1.5_wp
+                        DO ji = 10, jpidta
+                          zi = MIN(FLOAT(ji - 10)/FLOAT(jpidta - 10), 1.0 )
+                          zdta(ji,:) = MAX(rn_bathy*zi, 1.5) 
+                          IF(lwp)write(numout,*) 'ZDTA ',ji,zi,zdta(ji,1)
+                        END DO
+                        !!DO ji = 1, jpidta 
+                        !!  zi = 1.0-EXP(-0.045*(ji-25.0)**2)
+                        !!  zdta(ji,:) = MAX(rn_bathy*zi, 1.5)
+                        !!  IF(lwp)write(numout,*) 'ZDTA ',ji,zi,zdta(ji,1)
+                        !!END DO
+                        zdta(1:2,:) = -2._wp
+                        zdta(jpidta-1:jpidta,:) = -2._wp
+                        zdta(:,1) = -2._wp
+                        zdta(:,jpjdta) = -2._wp
+                        zdta(:,1:3) = -2._wp
+                        zdta(:,jpjdta-2:jpjdta) = -2._wp
+                        !                                     ! ====================
+                     CASE ( 2, 3 )                            ! WAD 2 or 3  configuration
+                        !                                     ! ====================
+                        !
+                        IF(lwp) WRITE(numout,*)
+                        IF(lwp) WRITE(numout,*) 'zgr_bat : Parobolic EW channel'
+                        IF(lwp) WRITE(numout,*) '~~~~~~~~~~'
+                        !
+                        DO ji = 1, jpidta
+                          zi = MAX(1.0-FLOAT((ji-25)**2)/484.0, 0.0 )
+                          zi = MAX(1.0-FLOAT((ji-25)**2)/484.0, -2.0 )
+                          zdta(ji,:) = MAX(rn_bathy*zi, -20.0)
+                          IF(lwp)write(numout,*) 'ZDTA ',ji,zi,zdta(ji,1)
+                        END DO
+                        zdta(1:2,:) = -2._wp
+                        zdta(jpidta-1:jpidta,:) = -2._wp
+                        zdta(:,1) = -2._wp
+                        zdta(:,jpjdta) = -2._wp
+                        zdta(:,1:3) = -2._wp
+                        zdta(:,jpjdta-2:jpjdta) = -2._wp
+                        !                                     ! ====================
+                     CASE ( 4 )                               ! WAD 4 configuration
+                        !                                     ! ====================
+                        !
+                        IF(lwp) WRITE(numout,*)
+                        IF(lwp) WRITE(numout,*) 'zgr_bat : Parobolic bowl'
+                        IF(lwp) WRITE(numout,*) '~~~~~~~~~~'
+                        !
+                        DO ji = 1, jpidta
+                          zi = MAX(1.0-FLOAT((ji-25)**2)/484.0, -2.0 )
+                        DO jj = 1, jpjdta
+                          zj = MAX(1.0-FLOAT((jj-17)**2)/196.0, -2.0 )
+                          zdta(ji,jj) = MAX(rn_bathy*zi*zj, -2.0)
+                        END DO
+                          IF(lwp)write(numout,*) 'ZDTA ',ji,zi,zdta(ji,1)
+                        END DO
+                        zdta(1:2,:) = -2._wp
+                        zdta(jpidta-1:jpidta,:) = -2._wp
+                        zdta(:,1) = -2._wp
+                        zdta(:,jpjdta) = -2._wp
+                        zdta(:,1:3) = -2._wp
+                        zdta(:,jpjdta-2:jpjdta) = -2._wp
+                        !                                    ! ===========================
+                     CASE ( 5 )                              ! WAD 5 configuration
+                        !                                    ! ====================
+                        !
+                        IF(lwp) WRITE(numout,*)
+                        IF(lwp) WRITE(numout,*) 'zgr_bat : Double slope with shelf'
+                        IF(lwp) WRITE(numout,*) '~~~~~~~~~~'
+                        !
+                        DO ji = 1, jpidta
+                          zi = MIN(FLOAT(ji)/FLOAT(jpidta - 5), 1.0 )
+                          zdta(ji,:) = MAX(rn_bathy*zi, 0.5)
+                          IF(lwp)write(numout,*) 'ZDTA ',ji,zi,zdta(ji,1)
+                        END DO
+                        DO ji = jpidta,46,-1
+                          zdta(ji,:) = 10.0
+                          IF(lwp)write(numout,*) 'ZDTA ',ji,zi,zdta(ji,1)
+                        END DO
+                        DO ji = 46,20,-1
+                          zi = 7.5/25.
+                          zdta(ji,:) = MAX(10. - zi*(47.-ji),2.5)
+                          IF(lwp)write(numout,*) 'ZDTA ',ji,zi,zdta(ji,1)
+                        END DO
+                        DO ji = 19,15,-1
+                          zdta(ji,:) = 2.5
+                          IF(lwp)write(numout,*) 'ZDTA ',ji,zi,zdta(ji,1)
+                        END DO
+                        DO ji = 15,4,-1
+                          zi = 2.0/11.0
+                          zdta(ji,:) = MAX(2.5 - zi*(16-ji), 0.5)
+                          IF(lwp)write(numout,*) 'ZDTA ',ji,zi,zdta(ji,1)
+                        END DO
+                        DO ji = 4,1,-1
+                          zdta(ji,:) = 0.5
+                          IF(lwp)write(numout,*) 'ZDTA ',ji,zi,zdta(ji,1)
+                        END DO
+                        !                                    ! ===========================
+                        zdta(1:2,:) = -4._wp
+                        zdta(jpidta-1:jpidta,:) = -4._wp
+                        zdta(:,1) = -4._wp
+                        zdta(:,jpjdta) = -4._wp
+                        zdta(:,1:3) = -4._wp
+                        zdta(:,jpjdta-2:jpjdta) = -4._wp
+                        !                                    ! ===========================
+                     CASE ( 6 )                              ! WAD 6 configuration
+                        !                                    ! ====================
+                        !
+                        IF(lwp) WRITE(numout,*)
+                        IF(lwp) WRITE(numout,*) 'zgr_bat : Parabolic channel with gaussian ridge'
+                        IF(lwp) WRITE(numout,*) '~~~~~~~~~~'
+                        !
+                        DO ji = 1, jpidta
+                          zi = MAX(1.0-FLOAT((ji-25)**2)/484.0, -2.0 )
+                          zj = 0.95*MAX(EXP(-1.0*FLOAT((ji-25)**2)/32.0) , 0.0 )
+                          zdta(ji,:) = MAX(rn_bathy*(zi-zj), -2.0)
+                          IF(lwp)write(numout,*) 'ZDTA ',ji,zi,zdta(ji,1)
+                        END DO
+                        zdta(1:2,:) = -4._wp
+                        zdta(jpidta-1:jpidta,:) = -4._wp
+                        zdta(:,1) = -4._wp
+                        zdta(:,jpjdta) = -4._wp
+                        zdta(:,1:3) = -4._wp
+                        zdta(:,jpjdta-2:jpjdta) = -4._wp
+                        !                                    ! ===========================
+                     CASE DEFAULT
+                        !                                    ! ===========================
+                        WRITE(ctmp1,*) 'WAD test with a ', jp_cfg,' option is not coded'
+                        !
+                        CALL ctl_stop( ctmp1 )
+                        !
+                  END SELECT
+               END IF
+               !
                IF( ln_sco ) THEN                                   ! s-coordinate (zsc       ): idta()=jpk
                   idta(:,:) = jpkm1
@@ -2185,13 +2327,11 @@
       CALL lbc_lnk( e3vw_0, 'V', 1._wp )
       !
-      IF( .NOT.ln_wd ) THEN
-        WHERE( e3t_0 (:,:,:) == 0._wp )   e3t_0 (:,:,:) = 1._wp
-        WHERE( e3u_0 (:,:,:) == 0._wp )   e3u_0 (:,:,:) = 1._wp
-        WHERE( e3v_0 (:,:,:) == 0._wp )   e3v_0 (:,:,:) = 1._wp
-        WHERE( e3f_0 (:,:,:) == 0._wp )   e3f_0 (:,:,:) = 1._wp
-        WHERE( e3w_0 (:,:,:) == 0._wp )   e3w_0 (:,:,:) = 1._wp
-        WHERE( e3uw_0(:,:,:) == 0._wp )   e3uw_0(:,:,:) = 1._wp
-        WHERE( e3vw_0(:,:,:) == 0._wp )   e3vw_0(:,:,:) = 1._wp
-      END IF
+      WHERE( e3t_0 (:,:,:) == 0._wp )   e3t_0 (:,:,:) = 1._wp
+      WHERE( e3u_0 (:,:,:) == 0._wp )   e3u_0 (:,:,:) = 1._wp
+      WHERE( e3v_0 (:,:,:) == 0._wp )   e3v_0 (:,:,:) = 1._wp
+      WHERE( e3f_0 (:,:,:) == 0._wp )   e3f_0 (:,:,:) = 1._wp
+      WHERE( e3w_0 (:,:,:) == 0._wp )   e3w_0 (:,:,:) = 1._wp
+      WHERE( e3uw_0(:,:,:) == 0._wp )   e3uw_0(:,:,:) = 1._wp
+      WHERE( e3vw_0(:,:,:) == 0._wp )   e3vw_0(:,:,:) = 1._wp
 
 #if defined key_agrif
@@ -2295,24 +2435,24 @@
                DO jk = 1, mbathy(ji,jj)
                  ! check coordinate is monotonically increasing
-                 IF (e3w_n(ji,jj,jk) <= 0._wp .OR. e3t_n(ji,jj,jk) <= 0._wp ) THEN
+                 IF (e3w_0(ji,jj,jk) <= 0._wp .OR. e3t_0(ji,jj,jk) <= 0._wp ) THEN
                     WRITE(ctmp1,*) 'ERROR zgr_sco :   e3w   or e3t   =< 0  at point (i,j,k)= ', ji, jj, jk
                     WRITE(numout,*) 'ERROR zgr_sco :   e3w   or e3t   =< 0  at point (i,j,k)= ', ji, jj, jk
-                    WRITE(numout,*) 'e3w',e3w_n(ji,jj,:)
-                    WRITE(numout,*) 'e3t',e3t_n(ji,jj,:)
+                    WRITE(numout,*) 'e3w',e3w_0(ji,jj,:)
+                    WRITE(numout,*) 'e3t',e3t_0(ji,jj,:)
                     CALL ctl_stop( ctmp1 )
                  ENDIF
                  ! and check it has never gone negative
-                 IF( gdepw_n(ji,jj,jk) < 0._wp .OR. gdept_n(ji,jj,jk) < 0._wp ) THEN
+                 IF( gdepw_0(ji,jj,jk) < 0._wp .OR. gdept_0(ji,jj,jk) < 0._wp ) THEN
                     WRITE(ctmp1,*) 'ERROR zgr_sco :   gdepw or gdept =< 0  at point (i,j,k)= ', ji, jj, jk
                     WRITE(numout,*) 'ERROR zgr_sco :   gdepw   or gdept   =< 0  at point (i,j,k)= ', ji, jj, jk
-                    WRITE(numout,*) 'gdepw',gdepw_n(ji,jj,:)
-                    WRITE(numout,*) 'gdept',gdept_n(ji,jj,:)
+                    WRITE(numout,*) 'gdepw',gdepw_0(ji,jj,:)
+                    WRITE(numout,*) 'gdept',gdept_0(ji,jj,:)
                     CALL ctl_stop( ctmp1 )
                  ENDIF
                  ! and check it never exceeds the total depth
-                 IF( gdepw_n(ji,jj,jk) > hbatt(ji,jj) ) THEN
+                 IF( gdepw_0(ji,jj,jk) > hbatt(ji,jj) ) THEN
                     WRITE(ctmp1,*) 'ERROR zgr_sco :   gdepw > hbatt  at point (i,j,k)= ', ji, jj, jk
                     WRITE(numout,*) 'ERROR zgr_sco :   gdepw > hbatt  at point (i,j,k)= ', ji, jj, jk
-                    WRITE(numout,*) 'gdepw',gdepw_n(ji,jj,:)
+                    WRITE(numout,*) 'gdepw',gdepw_0(ji,jj,:)
                     CALL ctl_stop( ctmp1 )
                  ENDIF
@@ -2321,8 +2461,8 @@
                DO jk = 1, mbathy(ji,jj)-1
                  ! and check it never exceeds the total depth
-                IF( gdept_n(ji,jj,jk) > hbatt(ji,jj) ) THEN
+                IF( gdept_0(ji,jj,jk) > hbatt(ji,jj) ) THEN
                     WRITE(ctmp1,*) 'ERROR zgr_sco :   gdept > hbatt  at point (i,j,k)= ', ji, jj, jk
                     WRITE(numout,*) 'ERROR zgr_sco :   gdept > hbatt  at point (i,j,k)= ', ji, jj, jk
-                    WRITE(numout,*) 'gdept',gdept_n(ji,jj,:)
+                    WRITE(numout,*) 'gdept',gdept_0(ji,jj,:)
                     CALL ctl_stop( ctmp1 )
                  ENDIF
Index: branches/2016/dev_NOC_2016/NEMOGCM/NEMO/OPA_SRC/DOM/istate.F90
===================================================================
--- branches/2016/dev_NOC_2016/NEMOGCM/NEMO/OPA_SRC/DOM/istate.F90	(revision 7338)
+++ branches/2016/dev_NOC_2016/NEMOGCM/NEMO/OPA_SRC/DOM/istate.F90	(revision 7339)
@@ -36,4 +36,5 @@
    USE domvvl          ! varying vertical mesh
    USE iscplrst        ! ice sheet coupling
+   USE wet_dry         ! wetting and drying (needed for wad_istate)
    !
    USE in_out_manager  ! I/O manager
@@ -105,4 +106,6 @@
          ELSEIF( cp_cfg == 'gyre' ) THEN         
             CALL istate_gyre                     ! GYRE  configuration : start from pre-defined T-S fields
+         ELSEIF( cp_cfg == 'wad' ) THEN         
+            CALL wad_istate                      ! WAD test configuration : start from pre-defined T-S fields and initial ssh slope
          ELSE                                    ! Initial T-S, U-V fields read in files
             IF ( ln_tsd_init ) THEN              ! read 3D T and S data at nit000
